Bug Hunting Session
Bug 123412 - Base: Unwanted disonnection from Firebird data source error message "connection shutdown caused by isc_service_attach"
Summary: Base: Unwanted disonnection from Firebird data source error message "connecti...
Status: UNCONFIRMED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Base (show other bugs)
Version:
(earliest affected)
6.2.0.2 rc
Hardware: All Mac OS X (All)
: medium minor
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: Database-Firebird-Default
  Show dependency treegraph
 
Reported: 2019-02-12 17:46 UTC by Tim
Modified: 2019-10-22 10:26 UTC (History)
4 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Tim 2019-02-12 17:46:54 UTC
Description:
After using LibreOffice with Text documents, if I open Base and try to access Tables, this is the message:

firebird_sdbc error:
*connection shutdown
caused by
'isc_service_attach'

Then I just shut down LibreOffice, restart, and it works.

Steps to Reproduce:
1.Work with several LibreOffice Text Documents.
2.Open Base file.
3.Try to open a Table or ejecute Forms...

Actual Results:
Error

Expected Results:
Be able to open tables, forms, queries or reports.


Reproducible: Always


User Profile Reset: No



Additional Info:
Version: 6.2.0.3
Build ID: 98c6a8a1c6c7b144ce3cc729e34964b47ce25d62
CPU threads: 2; OS: Mac OS X 10.13.6; UI render: default; VCL: osx; 
Locale: es-ES (es_ES.UTF-8); UI-Language: en-US
Calc: threaded
Comment 1 Alex Thurgood 2019-02-13 09:00:34 UTC
@Tim : we will need more information than what you have given as currently your description is too vague.

1) "Work with several Text documents"

- what kind of work ?

- which kind of documents do you mean exactly (ODT, other file format, CSV,Excel, Calc, RTF) ?

2) "Open Base file."

- which kind of database file (hsqldb embedded, firebird embedded, some other connection to a DB engine, flat file (text) connection) ?

If the problem is caused by a particular Base file, then ideally, a copy of that file should be posted as an attachment here after removing any sensitive data.
Comment 2 Tim 2019-02-13 09:24:18 UTC
(In reply to Alex Thurgood from comment #1)
> @Tim : we will need more information than what you have given as currently
> your description is too vague.
> 
> 1) "Work with several Text documents"
> 
> - what kind of work ?
> 
> - which kind of documents do you mean exactly (ODT, other file format,
> CSV,Excel, Calc, RTF) ?
> 
> 2) "Open Base file."
> 
> - which kind of database file (hsqldb embedded, firebird embedded, some
> other connection to a DB engine, flat file (text) connection) ?
> 
> If the problem is caused by a particular Base file, then ideally, a copy of
> that file should be posted as an attachment here after removing any
> sensitive data.


Thanks!

1)

By "Text documents" I mean .ODT files.

By “work” I mean writing a newsletter, or any other thing, as a new file or editing an existing one.

2)

It happens with all my database files,, and some are hsqldb embedded and others are firebird embedded.

I think it started to happen since I merged some databases from hsqldt embedded to firebird embedded.
Comment 3 Alex Thurgood 2019-02-13 10:24:08 UTC
Unfortunately, no repro for me with :

Version: 6.2.0.3
Build ID: 98c6a8a1c6c7b144ce3cc729e34964b47ce25d62
Threads CPU : 4; OS : Mac OS X 10.14.2; UI Render : par défaut; VCL: osx; 
Locale : fr-FR (fr_FR.UTF-8); Langue IHM : fr-FR
Calc: threaded


1) Opened a first ODT documents - edited some text, saved and closed.

2) Opened StartCenter, chose a different ODT to load and edit, made some changes, saved and closed.

3) Opened an embedded hsqldb ODB file. Cancelled the migration to firebird.

4) Clicked on Tables, double-clicked on several tables, all of them opened without error.


@Vic : I can only assume that the problem reported is somehow linked to your LO user configuration profile, or that there is something more specific in what you are doing that we don't know about.
Comment 4 Alex Thurgood 2019-02-13 10:41:53 UTC
@Tim : the error message you see implies that the connection to the database engine was cut off somehow, but without further investigation, it will be difficult to nail down. A quick search with Google didn't really bring up any relevant results.
Comment 5 Tim 2019-02-13 10:50:23 UTC
(In reply to Alex Thurgood from comment #3)
> Unfortunately, no repro for me with :
> 
> Version: 6.2.0.3
> Build ID: 98c6a8a1c6c7b144ce3cc729e34964b47ce25d62
> Threads CPU : 4; OS : Mac OS X 10.14.2; UI Render : par défaut; VCL: osx; 
> Locale : fr-FR (fr_FR.UTF-8); Langue IHM : fr-FR
> Calc: threaded
> 
> 
> 1) Opened a first ODT documents - edited some text, saved and closed.
> 
> 2) Opened StartCenter, chose a different ODT to load and edit, made some
> changes, saved and closed.
> 
> 3) Opened an embedded hsqldb ODB file. Cancelled the migration to firebird.
> 
> 4) Clicked on Tables, double-clicked on several tables, all of them opened
> without error.
> 
> 
> @Vic : I can only assume that the problem reported is somehow linked to your
> LO user configuration profile, or that there is something more specific in
> what you are doing that we don't know about.


Yes, and I can do the same! But after some time it happens that then I can't access the Tables within the database! And I have no idea what could make the difference!

I understand that like that it's almost impossible to know why. If a get to find out any other hint I let you know. Thanks.
Comment 6 Tim 2019-02-14 18:19:02 UTC
To reset preferences... I've deleted LibreOffice folder in /Library/Application Support/ and didn't solve the problem.
Comment 7 Tim 2019-02-20 11:28:45 UTC
I've tried it opening LibreOffice in Safe Mode and it happens the same.
Comment 8 Tim 2019-02-25 23:02:11 UTC
Today with firebird embedded database I got the error, but not with an HSQLDB Embedded!
Comment 9 Alex Thurgood 2019-02-26 09:41:58 UTC
According to this page :

https://fossies.org/linux/Firebird/doc/Using_OO_API.html

isc_service_attach is deprecated in FB3 in favour of 
IService* attachServiceManager()

We are still using this call in many of the cxx and cpp files (e.g. burp.cpp, call_service.cpp, Connection.cxx, etc)

@Tamas : thoughts ?
Comment 10 Tim 2019-04-06 17:00:38 UTC
When I restart LibreOffice and open the database file, it seems to work ok until I open some .ODT files and after a while then I can't access the tables within the database. As it's not immediate, I don't know how many .ODT files I have to open or for how long until the error comes up in the database. So what I've seemed to find put is that the database will work well as long as I don't open .ODT files.
Comment 11 Tim 2019-04-16 11:41:04 UTC
Last testing:

- In safe mode it happens the same.

- This is NEW information: I've discovered that when I open the data base file and can work with it without getting an error message, as long as I don't close it, no error will appear even days after, and no mater what ever writer files I open and close and work on them. But if I close the database file, and open and close and edit writer files, and after that I open the data base then I'll get the error message and can't access the tables within the database.
Comment 12 Julien Nabet 2019-05-15 14:18:59 UTC
(In reply to Alex Thurgood from comment #9)
> According to this page :
> 
> https://fossies.org/linux/Firebird/doc/Using_OO_API.html
> 
> isc_service_attach is deprecated in FB3 in favour of 
> IService* attachServiceManager()
Even if it comes from Firebird, it doesn't seem about Firebird using but about using OO (so also LO) API on Firebird

> 
> We are still using this call in many of the cxx and cpp files (e.g.
> burp.cpp, call_service.cpp, Connection.cxx, etc)
> ...
Opengroking isc_service_attach:
https://opengrok.libreoffice.org/search?project=core&full=isc_service_attach&defs=&refs=&path=&hist=&type=&si=full
where it's used for attachServiceManager

Idem for isc_service_detach, only used for detachServiceManager

Did I miss something?
Comment 13 Julien Nabet 2019-05-15 14:20:40 UTC
Tim: could you give a try to 6.2.3? Indeed, perhaps https://cgit.freedesktop.org/libreoffice/core/commit/?id=6affbd2b57a336749a6a2ab3466a4e652a7ff365 may help?
Comment 14 Tim 2019-05-15 15:58:26 UTC
(In reply to Julien Nabet from comment #13)
> Tim: could you give a try to 6.2.3? Indeed, perhaps
> https://cgit.freedesktop.org/libreoffice/core/commit/
> ?id=6affbd2b57a336749a6a2ab3466a4e652a7ff365 may help?

I'm already using 6.2.3.2
Comment 15 Alex Thurgood 2019-05-16 09:40:22 UTC
(In reply to Julien Nabet from comment #12)

> Opengroking isc_service_attach:
> https://opengrok.libreoffice.org/
> search?project=core&full=isc_service_attach&defs=&refs=&path=&hist=&type=&si=
> full
> where it's used for attachServiceManager
> 
> Idem for isc_service_detach, only used for detachServiceManager
> 
> Did I miss something?

No, that was my bad, those other cpp files came from the fb tarball. Indeed, only Connection.cxx seems to contain calls to isc_service_attach/detach.
Comment 16 Tim 2019-05-16 15:08:40 UTC
What's fanny is that if I start LibreOffice and open a base data file, as long I don't close it, it'll not give the error. I can work around with writer files (open, edit, create new files), and open other base data, and It'll go ok!

The error comes only if I work with Writer files first and after a while I open the data base!
Comment 17 Tim 2019-05-28 09:18:17 UTC
Another observation:

With a new Data Base with embedded firebird I can go to Edit -> Database -> Advanced Settings...

In a migrated Data Base with hsqldb embedded I go to Edit -> Database and then all options are in gray and can't access Advanced Settings...
Comment 18 Xisco Faulí 2019-10-21 12:17:15 UTC
Hello Tim,
Could you please try to reproduce it with the latest version of LibreOffice
from https://www.libreoffice.org/download/libreoffice-fresh/ ?
I have set the bug's status to 'NEEDINFO'. Please change it back to
'UNCONFIRMED' if the bug is still present in the latest version.
Comment 19 Tim 2019-10-22 10:26:35 UTC
Thank you Xisco for your interest.
I regularly update LibreOffice and with 6.3.2.1 it's all the same. I have the same bug.